{ ****************************************************************** }
{                                                                    }
{   VCL component TRegistrySetting                                   }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file d:\programming\components\registrysetting\registrysetting.cd }
{   on 26 Dec 2000 at 20:34                                          }
{                                                                    }
{   A public domain component by Darius Blaszijk                     }
{                                                                    }
{ ****************************************************************** }

unit RegistrySetting;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Registry;

{ Unit-wide declarations }

type TKeyType = (vtDateTime,
                 vtFloat,
                 vtInteger,
                 vtString);
     TRootRegistryKey = (rHKEY_CLASSES_ROOT,
                         rHKEY_CURRENT_USER,
                         rHKEY_LOCAL_MACHINE,
                         rHKEY_CURRENT_CONFIG);


type
  TRegistrySetting = class(TComponent)
    private
      { Private fields of TRegistrySetting }
        FActive : Boolean;
        FAsDateTime : TDateTime;
        FAsFloat : Double;
        FAsInteger : Integer;
        FAsString : String;
        FPath : String;
        FRootKey : TRootRegistryKey;
        FValueName : String;
        FValueType : TKeyType;

      { Private methods of TRegistrySetting }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        function GetActive : Boolean;
        procedure SetActive(Value : Boolean);
        function GetAsDateTime : TDateTime;
        procedure SetAsDateTime(Value : TDateTime);
        function GetAsFloat : Double;
        procedure SetAsFloat(Value : Double);
        function GetAsInteger : Integer;
        procedure SetAsInteger(Value : Integer);
        function GetAsString : String;
        procedure SetAsString(Value : String);
        function GetPath : String;
        procedure SetPath(Value : String);
        function GetRootKey : TRootRegistryKey;
        procedure SetRootKey(Value : TRootRegistryKey);
        function GetValueName : String;
        procedure SetValueName(Value : String);
        function GetValueType : TKeyType;
        procedure SetValueType(Value : TKeyType);
        procedure GetRegValue;
        procedure SetRegValue;

    protected
      { Protected fields of TRegistrySetting }

      { Protected methods of TRegistrySetting }
        procedure Loaded; override;

    public
      { Public fields and properties of TRegistrySetting }

      { Public methods of TRegistrySetting }
        function ConvertRootKey : HKEY;
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        function Execute : Boolean;

    published
      { Published properties of TRegistrySetting }
        property Active : Boolean read GetActive write SetActive;
        property AsDateTime : TDateTime read GetAsDateTime write SetAsDateTime;
        property AsFloat : Double read GetAsFloat write SetAsFloat;
        property AsInteger : Integer read GetAsInteger write SetAsInteger;
        property AsString : String read GetAsString write SetAsString;
        property Path : String read GetPath write SetPath;
        property RootKey : TRootRegistryKey
             read GetRootKey write SetRootKey
             default rHKEY_CURRENT_USER;
        property ValueName : String read GetValueName write SetValueName;
        property ValueType : TKeyType read GetValueType write SetValueType;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TRegistrySetting with System as its
       default page on the Delphi component palette }
     RegisterComponents('System', [TRegistrySetting]);
end;

{ Method to set variable and property values and create objects }
procedure TRegistrySetting.AutoInitialize;
begin
     FRootKey := rHKEY_CURRENT_USER;
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure TRegistrySetting.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end; { of AutoDestroy }

function TRegistrySetting.GetActive : Boolean;
begin
     Result := FActive;
end;

procedure TRegistrySetting.SetActive(Value : Boolean);
begin
  FActive:=Value;
  if FActive=True then GetRegValue;
end;

function TRegistrySetting.GetAsDateTime : TDateTime;
begin
     Result := FAsDateTime;
end;

procedure TRegistrySetting.SetAsDateTime(Value : TDateTime);
begin
  FAsDateTime:=Value;
  if FActive=True then
    if FValueType=vtDateTime then SetRegValue;
end;

function TRegistrySetting.GetAsFloat : Double;
begin
     Result := FAsFloat;
end;

procedure TRegistrySetting.SetAsFloat(Value : Double);
begin
  FAsFloat:=Value;
  if FActive=True then
    if FValueType=vtFloat then SetRegValue;
end;

function TRegistrySetting.GetAsInteger : Integer;
begin
     Result := FAsInteger;
end;

procedure TRegistrySetting.SetAsInteger(Value : Integer);
begin
  FAsInteger:=Value;
  if FActive=True then
    if FValueType=vtInteger then SetRegValue;
end;

function TRegistrySetting.GetAsString : String;
begin
     Result := FAsString;
end;

procedure TRegistrySetting.SetAsString(Value : String);
begin
  FAsString:=Value;
  if FActive=True then
    if FValueType=vtString then SetRegValue;
end;

function TRegistrySetting.GetPath : String;
begin
     Result := FPath;
end;

procedure TRegistrySetting.SetPath(Value : String);
begin
     FPath := Value;
end;

function TRegistrySetting.GetRootKey : TRootRegistryKey;
begin
     Result := FRootKey;
end;

procedure TRegistrySetting.SetRootKey(Value : TRootRegistryKey);
begin
     FRootKey := Value;
end;

function TRegistrySetting.GetValueName : String;
begin
  Result:=FValueName;
end;

procedure TRegistrySetting.SetValueName(Value : String);
begin
  FValueName:=Value;
end;

function TRegistrySetting.GetValueType : TKeyType;
begin
  Result:=FValueType;
end;

procedure TRegistrySetting.SetValueType(Value : TKeyType);
begin
  FValueType:=Value;
  FActive:=False;
end;

function TRegistrySetting.ConvertRootKey : HKEY;
begin
  Result:=0 ;
  case FRootKey of
    rHKEY_LOCAL_MACHINE  : Result:=HKEY_LOCAL_MACHINE;
    rHKEY_CLASSES_ROOT   : Result:=HKEY_CLASSES_ROOT;
    rHKEY_CURRENT_CONFIG : Result:=HKEY_CURRENT_CONFIG;
    rHKEY_CURRENT_USER   : Result:=HKEY_CURRENT_USER;
  end ;
end;

constructor TRegistrySetting.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  AutoInitialize;

  { Code to perform other tasks when the component is created }
end;

destructor TRegistrySetting.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

function TRegistrySetting.Execute : Boolean;
begin
     { Perform the component operation }

     { Return True if the operation was successful, False otherwise }
     Result := True
end;

procedure TRegistrySetting.GetRegValue;
var SystemReg : TRegistry;
    SystemDataInfo : TRegDataInfo;
begin
  SystemReg:=TRegistry.Create;
  SystemReg.RootKey:=ConvertRootKey;
  SystemReg.OpenKey(FPath,True);
  if not SystemReg.ValueExists(FValueName) then SetRegValue;
  SystemReg.GetDataInfo(FValueName,SystemDataInfo);
  case FValueType of
    vtDateTime : FAsDateTime:=SystemReg.ReadDateTime(FValueName);
    vtFloat    : FAsFloat:=SystemReg.ReadFloat(FValueName);
    vtInteger  : FAsInteger:=SystemReg.ReadInteger(FValueName);
    vtString   : FAsString:=SystemReg.ReadString(FValueName);
  end;
  SystemReg.Free;
end;

procedure TRegistrySetting.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

procedure TRegistrySetting.SetRegValue;
var SystemReg : TRegistry;
begin
  SystemReg:=TRegistry.Create;
  SystemReg.RootKey:=ConvertRootKey;
  SystemReg.OpenKey(FPath,True);
  case FValueType of
    vtDateTime : SystemReg.WriteDateTime(FValueName,FAsDateTime);
    vtFloat    : SystemReg.WriteFloat(FValueName,FAsFloat);
    vtInteger  : SystemReg.WriteInteger(FValueName,FAsInteger);
    vtString   : SystemReg.WriteString(FValueName,FAsString);
  end;
  SystemReg.Free;
end;


end.
